#! /usr/bin/env python

import string, re

def mangle_name(classname):
    return string.replace(classname, "FX", "FXPy")

def unmangle_name(classname):
    return string.replace(classname, "FXPy", "FX")

def gen_dock(classname, mc):
    print "void %s::dock(){ ::_dock(this); }" % mc
    print "void %s::_dock(){ %s::dock(); }\n" % (mc,classname)

def gen_undock(classname, mc):
    print "void %s::undock(){ ::_undock(this); }" % mc
    print "void %s::_undock(){ %s::undock(); }\n" % (mc,classname)

def gen_show(classname, mc):
    "Generate wrappers for show() function"
    print "void %s::show(){ ::FXPyShow(this); }" % mc
    print "void %s::_show(){ %s::show(); }\n" % (mc,classname)

def gen_hide(classname, mc):
    "Generate wrappers for hide() function"
    print "void %s::hide(){ ::_hide(this); }" % mc
    print "void %s::_hide(){ %s::hide(); }\n" % (mc,classname)

def gen_enable(classname, mc):
    print "void %s::enable(){ ::_enable(this); }" % mc
    print "void %s::_enable(){ %s::enable(); }\n" % (mc,classname)

def gen_disable(classname, mc):
    print "void %s::disable(){ ::_disable(this); }" % mc
    print "void %s::_disable(){ %s::disable(); }\n" % (mc,classname)

def gen_canFocus(classname, mc):
    print "FXbool %s::canFocus() const { return ::_canFocus(this); }" % mc
    print "FXbool %s::_canFocus() const { return %s::canFocus(); }\n" % (mc,classname)

def gen_setWindowFocus(classname, mc):
    print "void %s::setFocus(){ ::_setFocus(this); }" % mc
    print "void %s::_setFocus(){ %s::setFocus(); }\n" % (mc,classname)

def gen_killFocus(classname, mc):
    print "void %s::killFocus(){ ::_killFocus(this); }" % mc
    print "void %s::_killFocus(){ %s::killFocus(); }\n" % (mc,classname)

def gen_create(classname, mc):
    "Generate wrappers for create() function"
    print "void %s::create(){ ::FXPyCreate(this); }" % mc
    print "void %s::_create(){ %s::create(); }\n" % (mc,classname)

# Generate wrappers for detach() function
def gen_detach(classname, mc):
    print "void %s::detach(){ ::FXPyDetach(this); }" % mc
    print "void %s::_detach(){ %s::detach(); }\n" % (mc,classname)

# Generate wrappers for destroy() function
def gen_destroy(classname, mc):
    print "void %s::destroy(){ ::FXPyDestroy(this); }" % mc
    print "void %s::_destroy(){ %s::destroy(); }\n" % (mc,classname)

def gen_lower(classname, mc):
    print "void %s::lower(){ ::_lowerWindow(this); }" % mc
    print "void %s::_lowerWindow(){ %s::lower(); }\n" % (mc,classname)

def gen_move(classname, mc):
    print "void %s::move(FXint x,FXint y){ ::_move(this,x,y); }" % mc
    print "void %s::_move(FXint x,FXint y){ %s::move(x,y); }\n" % (mc,classname)

def gen_resize(classname, mc):
    print "void %s::resize(FXint w,FXint h){ ::_resize(this,w,h); }" % mc
    print "void %s::_resize(FXint w,FXint h){ %s::resize(w,h); }\n" % (mc,classname)

def gen_contains(classname, mc):
    print "FXbool %s::contains(FXint x,FXint y) const { return ::_contains(this,x,y); }" % mc
    print "FXbool %s::_contains(FXint x,FXint y) const { return %s::contains(x,y); }\n" % (mc,classname)

def gen_position(classname, mc):
    print "void %s::position(FXint x,FXint y,FXint w,FXint h){ ::_position(this,x,y,w,h); }" % mc
    print "void %s::_position(FXint x,FXint y,FXint w,FXint h){ %s::position(x,y,w,h); }\n" % (mc,classname)

def gen_isComposite(classname, mc):
    print "FXbool %s::isComposite() const { return ::_isComposite(this); }" % mc
    print "FXbool %s::_isComposite() const { return %s::isComposite(); }\n" % (mc,classname)

def gen_doesSaveUnder(classname, mc):
    print "FXbool %s::doesSaveUnder() const { return ::_doesSaveUnder(this); }" % mc
    print "FXbool %s::_doesSaveUnder() const { return %s::doesSaveUnder(); }\n" % (mc,classname)

# Generate wrappers for handle() function
def gen_handle(classname, mc):
    print "long %s::_handle(FXObject* sender,FXSelector sel,void* ptr){" % (mc)
    print "  return %s::handle(sender,sel,ptr);" % (classname)
    print "  }\n"


def gen_onDefault(classname, mc):
    print "long %s::onDefault(FXObject* sender,FXSelector sel,void* ptr){" % mc
    print "  return ::_onDefault(this,sender,sel,ptr);"
    print "  }\n"
    print "long %s::_onDefault(FXObject* sender,FXSelector sel,void* ptr){" % mc
    print "  return %s::onDefault(sender,sel,ptr);" % classname
    print "  }\n"


# Generate wrappers for getDefaultWidth()
def gen_getDefaultWidth(classname, mc):
    print 'FXint %s::getDefaultWidth() { return ::_getDefaultWidth(this); }' % mc
    print 'FXint %s::_getDefaultWidth() { return %s::getDefaultWidth(); }\n' % (mc, classname)

def gen_getWidthForHeight(classname, mc):
    print 'FXint %s::getWidthForHeight(FXint h) { return ::_getWidthForHeight(this,h); }' % mc
    print 'FXint %s::_getWidthForHeight(FXint h) { return %s::getWidthForHeight(h); }\n' % (mc, classname)

# Generate wrappers for getDefaultHeight()
def gen_getDefaultHeight(classname, mc):
    print 'FXint %s::getDefaultHeight() { return ::_getDefaultHeight(this); }' % mc
    print 'FXint %s::_getDefaultHeight() { return %s::getDefaultHeight(); }\n' % (mc, classname)

def gen_getHeightForWidth(classname, mc):
    print 'FXint %s::getHeightForWidth(FXint w) { return ::_getHeightForWidth(this,w); }' % mc
    print 'FXint %s::_getHeightForWidth(FXint w) { return %s::getHeightForWidth(w); }\n' % (mc, classname)

# Generate wrappers for getWidth(const FXTreeList* list)
def gen_FXTreeItem_getWidth(classname, mc):
    print 'FXint %s::getWidth(const FXTreeList* list) const { return ::_getWidth(this, list); }' % mc
    print 'FXint %s::_getWidth(const FXTreeList* list) const { return %s::getWidth(list); }\n' % (mc, classname)

# Generate wrappers for getHeight(const FXTreeList* list)
def gen_FXTreeItem_getHeight(classname, mc):
    print 'FXint %s::getHeight(const FXTreeList* list) const { return ::_getHeight(this, list); }' % mc
    print 'FXint %s::_getHeight(const FXTreeList* list) const { return %s::getHeight(list); }\n' % (mc, classname)

# Generate wrappers for getWidth(const FXHeader* header)
def gen_FXHeaderItem_getWidth(classname, mc):
    print 'FXint %s::getWidth(const FXHeader* header) const { return ::_getWidth(this, header); }' % mc
    print 'FXint %s::_getWidth(const FXHeader* header) const { return %s::getWidth(header); }\n' % (mc, classname)

# Generate wrappers for getHeight(const FXHeader* header)
def gen_FXHeaderItem_getHeight(classname, mc):
    print 'FXint %s::getHeight(const FXHeader* header) const { return ::_getHeight(this, header); }' % mc
    print 'FXint %s::_getHeight(const FXHeader* header) const { return %s::getHeight(header); }\n' % (mc, classname)

# Generate wrappers for getWidth(const FXIconList* list)
def gen_FXIconItem_getWidth(classname, mc):
    print 'FXint %s::getWidth(const FXIconList* list) const { return ::_getWidth(this, list); }' % mc
    print 'FXint %s::_getWidth(const FXIconList* list) const { return %s::getWidth(list); }\n' % (mc, classname)

# Generate wrappers for getHeight(const FXIconList* header)
def gen_FXIconItem_getHeight(classname, mc):
    print 'FXint %s::getHeight(const FXIconList* list) const { return ::_getHeight(this, list); }' % mc
    print 'FXint %s::_getHeight(const FXIconList* list) const { return %s::getHeight(list); }\n' % (mc, classname)

# Generate wrappers for getWidth(const FXList* list)
def gen_FXListItem_getWidth(classname, mc):
    print 'FXint %s::getWidth(const FXList* list) const { return ::_getWidth(this, list); }' % mc
    print 'FXint %s::_getWidth(const FXList* list) const { return %s::getWidth(list); }\n' % (mc, classname)

# Generate wrappers for getHeight(const FXList* header)
def gen_FXListItem_getHeight(classname, mc):
    print 'FXint %s::getHeight(const FXList* list) const { return ::_getHeight(this, list); }' % mc
    print 'FXint %s::_getHeight(const FXList* list) const { return %s::getHeight(list); }\n' % (mc, classname)

# Generate wrappers for getWidth(const FXTable* table)
def gen_FXTableItem_getWidth(classname, mc):
    print 'FXint %s::getWidth(const FXTable* table) const { return ::_getWidth(this, table); }' % mc
    print 'FXint %s::_getWidth(const FXTable* table) const { return %s::getWidth(table); }\n' % (mc, classname)

# Generate wrappers for getHeight(const FXTable* table)
def gen_FXTableItem_getHeight(classname, mc):
    print 'FXint %s::getHeight(const FXTable* table) const { return ::_getHeight(this, table); }' % mc
    print 'FXint %s::_getHeight(const FXTable* table) const { return %s::getHeight(table); }\n' % (mc, classname)

# Wrappers for FXGLObject virtuals
def gen_FXGLObject_draw(classname, mc):
    print 'void %s::draw(FXGLViewer* viewer) { ::_draw(this, viewer); }' % mc
    print 'void %s::_draw(FXGLViewer* viewer) { %s::draw(viewer); }\n' % (mc, classname)

def gen_FXGLObject_hit(classname, mc):
    print 'void %s::hit(FXGLViewer* viewer) { ::_hit(this, viewer); }' % mc
    print 'void %s::_hit(FXGLViewer* viewer) { %s::hit(viewer); }\n' % (mc, classname)

def gen_FXGLObject_canDrag(classname, mc):
    print 'FXbool %s::canDrag() const { return ::_canDrag(this); }' % mc
    print 'FXbool %s::_canDrag() const { return %s::canDrag(); }\n' % (mc, classname)

def gen_FXGLObject_canDelete(classname, mc):
    print 'FXbool %s::canDelete() const { return ::_canDelete(this); }' % mc
    print 'FXbool %s::_canDelete() const { return %s::canDelete(); }\n' % (mc, classname)

def gen_FXGLObject_drag(classname, mc):
    print 'FXbool %s::drag(FXGLViewer* viewer,FXint fx,FXint fy,FXint tx,FXint ty) { return ::_drag(this,viewer,fx,fy,tx,ty); }' % mc
    print 'FXbool %s::_drag(FXGLViewer* viewer,FXint fx,FXint fy,FXint tx,FXint ty) { return %s::drag(viewer,fx,fy,tx,ty); }\n' % (mc, classname)

# Generate wrappers for layout()
def gen_layout(classname, mc):
    print 'void %s::layout() { ::_layout(this); }' % mc
    print 'void %s::_layout() { %s::layout(); }\n' % (mc, classname)

def gen_recalc(classname, mc):
    print 'void %s::recalc() { ::_recalc(this); }' % mc
    print 'void %s::_recalc() { %s::recalc(); }\n' % (mc, classname)

def gen_setText(classname, mc):
    print 'void %s::setText(const FXString& text) { ::_setText(this, text); }' % mc
    print 'void %s::_setText(const FXString& text) { %s::setText(text); }\n' % (mc, classname)

def gen_setIcon(classname, mc):
    print 'void %s::setIcon(FXIcon *icn) { ::_setIcon(this, icn); }' % mc
    print 'void %s::_setIcon(FXIcon *icn) { %s::setIcon(icn); }\n' % (mc, classname)

def gen_setMiniIcon(classname, mc):
    print 'void %s::setMiniIcon(FXIcon *icn) { ::_setMiniIcon(this, icn); }' % mc
    print 'void %s::_setMiniIcon(FXIcon *icn) { %s::setMiniIcon(icn); }\n' % (mc, classname)

def gen_setBigIcon(classname, mc):
    print 'void %s::setBigIcon(FXIcon *icn) { ::_setBigIcon(this, icn); }' % mc
    print 'void %s::_setBigIcon(FXIcon *icn) { %s::setBigIcon(icn); }\n' % (mc, classname)

def gen_setOpenIcon(classname, mc):
    print 'void %s::setOpenIcon(FXIcon *icn) { ::_setOpenIcon(this, icn); }' % mc
    print 'void %s::_setOpenIcon(FXIcon *icn) { %s::setOpenIcon(icn); }\n' % (mc, classname)

def gen_setClosedIcon(classname, mc):
    print 'void %s::setClosedIcon(FXIcon *icn) { ::_setClosedIcon(this, icn); }' % mc
    print 'void %s::_setClosedIcon(FXIcon *icn) { %s::setClosedIcon(icn); }\n' % (mc, classname)

def gen_setItemFocus(classname, mc):
    print 'void %s::setFocus(FXbool focus) { ::_setFocus(this, focus); }' % mc
    print 'void %s::_setFocus(FXbool focus) { %s::setFocus(focus); }\n' % (mc, classname)

def gen_setSelected(classname, mc):
    print 'void %s::setSelected(FXbool selected) { ::_setSelected(this, selected); }' % mc
    print 'void %s::_setSelected(FXbool selected) { %s::setSelected(selected); }\n' % (mc, classname)

def gen_setOpened(classname, mc):
    print 'void %s::setOpened(FXbool opened) { ::_setOpened(this, opened); }' % mc
    print 'void %s::_setOpened(FXbool opened) { %s::setOpened(opened); }\n' % (mc, classname)

def gen_setExpanded(classname, mc):
    print 'void %s::setExpanded(FXbool expanded) { ::_setExpanded(this, expanded); }' % mc
    print 'void %s::_setExpanded(FXbool expanded) { %s::setExpanded(expanded); }\n' % (mc, classname)

def gen_setEnabled(classname, mc):
    print 'void %s::setEnabled(FXbool enabled) { ::_setEnabled(this, enabled); }' % mc
    print 'void %s::_setEnabled(FXbool enabled) { %s::setEnabled(enabled); }\n' % (mc, classname)

def gen_setDraggable(classname, mc):
    print 'void %s::setDraggable(FXbool draggable) { ::_setDraggable(this, draggable); }' % mc
    print 'void %s::_setDraggable(FXbool draggable) { %s::setDraggable(draggable); }\n' % (mc, classname)

def gen_setMarked(classname, mc):
    print 'void %s::setMarked(FXbool marked) { ::_setMarked(this, marked); }' % mc
    print 'void %s::_setMarked(FXbool marked) { %s::setMarked(marked); }\n' % (mc, classname)


def gen_setJustify(classname, mc):
    print 'void %s::setJustify(FXuint justify) { ::_setJustify(this, justify); }' % mc
    print 'void %s::_setJustify(FXuint justify) { %s::setJustify(justify); }\n' % (mc, classname)

def gen_restore(classname, mc):
    print 'void %s::restore()  { ::_restore(this); }' % mc
    print 'void %s::_restore() { %s::restore(); }\n' % (mc, classname)

def gen_render(classname, mc):
    print 'void %s::render()  { ::_render(this); }' % mc
    print 'void %s::_render() { %s::render(); }\n' % (mc, classname)

def gen_scale(classname, mc):
    print 'void %s::scale(FXint w,FXint h)  { ::_scale(this,w,h); }' % mc
    print 'void %s::_scale(FXint w,FXint h) { %s::scale(w,h); }\n' % (mc, classname)

def gen_mirror(classname, mc):
    print 'void %s::mirror(FXbool horizontal,FXbool vertical)  { ::_mirror(this,horizontal,vertical); }' % mc
    print 'void %s::_mirror(FXbool horizontal,FXbool vertical) { %s::mirror(horizontal,vertical); }\n' % (mc, classname)

def gen_rotate(classname, mc):
    print 'void %s::rotate(FXint degrees)  { ::_rotate(this,degrees); }' % mc
    print 'void %s::_rotate(FXint degrees) { %s::rotate(degrees); }\n' % (mc, classname)

def gen_crop(classname, mc):
    print 'void %s::crop(FXint x,FXint y,FXint w,FXint h)  { ::_crop(this,x,y,w,h); }' % mc
    print 'void %s::_crop(FXint x,FXint y,FXint w,FXint h) { %s::crop(x,y,w,h); }\n' % (mc, classname)

def gen_savePixels(classname, mc):
    print 'void %s::savePixels(FXStream& store) const { ::_savePixels(this,store); }' % mc
    print 'void %s::_savePixels(FXStream& store) const { %s::savePixels(store); }\n' % (mc, classname)

def gen_loadPixels(classname, mc):
    print 'void %s::loadPixels(FXStream& store) { ::_loadPixels(this,store); }' % mc
    print 'void %s::_loadPixels(FXStream& store) { %s::loadPixels(store); }\n' % (mc, classname)

def gen_getContentWidth(classname, mc):
    print 'FXint %s::getContentWidth() { return ::_getContentWidth(this); }' % mc
    print 'FXint %s::_getContentWidth() { return %s::getContentWidth(); }\n' % (mc, classname)

def gen_getContentHeight(classname, mc):
    print 'FXint %s::getContentHeight() { return ::_getContentHeight(this); }' % mc
    print 'FXint %s::_getContentHeight() { return %s::getContentHeight(); }\n' % (mc, classname)

def gen_getViewportWidth(classname, mc):
    print 'FXint %s::getViewportWidth() { return ::_getViewportWidth(this); }' % mc
    print 'FXint %s::_getViewportWidth() { return %s::getViewportWidth(); }\n' % (mc, classname)

def gen_getViewportHeight(classname, mc):
    print 'FXint %s::getViewportHeight() { return ::_getViewportHeight(this); }' % mc
    print 'FXint %s::_getViewportHeight() { return %s::getViewportHeight(); }\n' % (mc, classname)

def gen_moveContents(classname, mc):
    print 'void %s::moveContents(FXint x,FXint y) { ::_moveContents(this,x,y); }' % mc
    print 'void %s::_moveContents(FXint x,FXint y) { %s::moveContents(x,y); }\n' % (mc, classname)

def gen_FXMDIChild_restore(classname, mc):
    print 'void %s::restore(FXbool notify) { ::_restore(this,notify); }' % mc
    print 'void %s::_restore(FXbool notify) { %s::restore(notify); }\n' % (mc, classname)

def gen_minimize(classname, mc):
    print 'void %s::minimize(FXbool notify) { ::_minimize(this,notify); }' % mc
    print 'void %s::_minimize(FXbool notify) { %s::minimize(notify); }\n' % (mc, classname)

def gen_maximize(classname, mc):
    print 'void %s::maximize(FXbool notify) { ::_maximize(this,notify); }' % mc
    print 'void %s::_maximize(FXbool notify) { %s::maximize(notify); }\n' % (mc, classname)

def preprocess(lines):
    newlines = []
    incline = re.compile('^ *#include')
    for line in lines:
	if incline.match(line):
	    words = string.split(line, '"')
	    filename = words[1]
	    for s in open(filename, 'r').readlines():
		newlines.append(s)
	else:
	    newlines.append(line)
    return newlines

# Map regular expressions to functions
funcmap = {
    re.compile('long _handle\(') : gen_handle,
    re.compile('long onDefault\(') : gen_onDefault,

    re.compile('void create\(') : gen_create,
    re.compile('void detach\(') : gen_detach,
    re.compile('void destroy\(') : gen_destroy,
    re.compile('void enable\(') : gen_enable,
    re.compile('void disable\(') : gen_disable,

    re.compile('FXbool canFocus\(') : gen_canFocus,
    re.compile('void setFocus\(\)') : gen_setWindowFocus,
    re.compile('void killFocus\(') : gen_killFocus,

    re.compile('FXint getDefaultHeight\(') : gen_getDefaultHeight,
    re.compile('FXint getWidthForHeight\(') : gen_getWidthForHeight,
    re.compile('FXint getDefaultWidth\(') : gen_getDefaultWidth,
    re.compile('FXint getHeightForWidth\(') : gen_getHeightForWidth,
    re.compile('void layout\(') : gen_layout,
    re.compile('void recalc\(') : gen_recalc,

    re.compile('void show\(') : gen_show,
    re.compile('void hide\(') : gen_hide,
    re.compile('void lower\(') : gen_lower,
    re.compile('void move\(') : gen_move,
    re.compile('void resize\(') : gen_resize,
    re.compile('void position\(') : gen_position,
    re.compile('FXbool contains\(') : gen_contains,
    re.compile('FXbool isComposite\(') : gen_isComposite,
    re.compile('FXbool doesSaveUnder\(') : gen_doesSaveUnder,

    re.compile('void restore\(\)') : gen_restore,
    re.compile('void render\(') : gen_render,
    re.compile('void scale\(') : gen_scale,
    re.compile('void mirror\(') : gen_mirror,
    re.compile('void rotate\(') : gen_rotate,
    re.compile('void crop\(') : gen_crop,
    re.compile('void savePixels\(') : gen_savePixels,
    re.compile('void loadPixels\(') : gen_loadPixels,

    re.compile('void dock\(') : gen_dock,
    re.compile('void undock\(') : gen_undock,

    re.compile('void minimize\(') : gen_minimize,
    re.compile('void maximize\(') : gen_maximize,
    re.compile('void restore\(FXbool notify') : gen_FXMDIChild_restore,

    re.compile('FXint getContentWidth\(') : gen_getContentWidth,
    re.compile('FXint getContentHeight\(') : gen_getContentHeight,
    re.compile('FXint getViewportWidth\(') : gen_getViewportWidth,
    re.compile('FXint getViewportHeight\(') : gen_getViewportHeight,
    re.compile('void moveContents\(') : gen_moveContents,

    re.compile('FXint getWidth\(const FXTreeList') : gen_FXTreeItem_getWidth,
    re.compile('FXint getHeight\(const FXTreeList') : gen_FXTreeItem_getHeight,

    re.compile('FXint getWidth\(const FXHeader') : gen_FXHeaderItem_getWidth,
    re.compile('FXint getHeight\(const FXHeader') : gen_FXHeaderItem_getHeight,

    re.compile('FXint getWidth\(const FXIconList') : gen_FXIconItem_getWidth,
    re.compile('FXint getHeight\(const FXIconList') : gen_FXIconItem_getHeight,

    re.compile('FXint getWidth\(const FXList') : gen_FXListItem_getWidth,
    re.compile('FXint getHeight\(const FXList') : gen_FXListItem_getHeight,

    re.compile('FXint getWidth\(const FXTable') : gen_FXTableItem_getWidth,
    re.compile('FXint getHeight\(const FXTable') : gen_FXTableItem_getHeight,

    re.compile('void setText\(const FXString') : gen_setText,
    re.compile('void setIcon\(FXIcon') : gen_setIcon,
    re.compile('void setBigIcon\(FXIcon') : gen_setBigIcon,
    re.compile('void setMiniIcon\(FXIcon') : gen_setMiniIcon,
    re.compile('void setOpenIcon\(FXIcon') : gen_setOpenIcon,
    re.compile('void setClosedIcon\(FXIcon') : gen_setClosedIcon,
    re.compile('void setFocus\(FXbool focus') : gen_setItemFocus,
    re.compile('void setSelected\(FXbool selected') : gen_setSelected,
    re.compile('void setOpened\(FXbool opened') : gen_setOpened,
    re.compile('void setExpanded\(FXbool expanded') : gen_setExpanded,
    re.compile('void setEnabled\(FXbool enabled') : gen_setEnabled,
    re.compile('void setDraggable\(FXbool draggable') : gen_setDraggable,
    re.compile('void setMarked\(FXbool marked') : gen_setMarked,
    re.compile('void setJustify\(FXuint justify') : gen_setJustify,

    re.compile('void draw\(FXGLViewer') : gen_FXGLObject_draw,
    re.compile('void hit\(FXGLViewer') : gen_FXGLObject_hit,
    re.compile('FXbool canDrag\(') : gen_FXGLObject_canDrag,
    re.compile('FXbool canDelete\(') : gen_FXGLObject_canDelete,
    re.compile('FXbool drag\(FXGLViewer') : gen_FXGLObject_drag,
}

# Main program starts here
if __name__ == '__main__':
    import sys
    sys.stdout = open('virtuals.cpp', 'w')
    lines = open("FXPy.h", "r").readlines()
    lines = preprocess(lines)
    class_header = re.compile("^class")
    expressions = funcmap.keys()
    for i in xrange(len(lines)):
	line = lines[i]
	classname = ""
	for expression in expressions:
	    if expression.search(line):
	        j = i
	        while j > 0:
		    if class_header.match(lines[j]):
		        words = string.split(lines[j])
		        classname = words[1]
		        func = funcmap[expression]
			func(unmangle_name(classname), classname)
		        break
		    j = j - 1
